import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import { Option } from 'fp-ts/lib/Option';
import { Validation } from 'fp-ts/lib/Validation';
export default class Decoder<a> {
    static andThen<a, b>(decoderFn: (value: a) => Decoder<b>, decoder: Decoder<a>): Decoder<b>;
    static andMap<a, b>(decoder: Decoder<a>): (fnInDecoder: Decoder<(value: a) => b>) => Decoder<b>;
    static array<a>(decoder: Decoder<a>): Decoder<a[]>;
    static at<a>(keys: string[], decoder: Decoder<a>): Decoder<a>;
    static boolean(): Decoder<boolean>;
    static fail<a>(message: string): Decoder<a>;
    static field<a>(key: string, decoder: Decoder<a>): Decoder<a>;
    static index<a>(key: number, decoder: Decoder<a>): Decoder<a>;
    static map<a, b>(fn: (value: a) => b, decoder: Decoder<a>): Decoder<b>;
    static map2<a, b, c>(fn: (valueA: a, valueB: b) => c, decoderA: Decoder<a>, decoderB: Decoder<b>): Decoder<c>;
    static map3<a, b, c, d>(fn: (valueA: a, valueB: b, valueC: c) => d, decoderA: Decoder<a>, decoderB: Decoder<b>, decoderC: Decoder<c>): Decoder<d>;
    static nonEmptyArray<a>(decoder: Decoder<a>): Decoder<NonEmptyArray<a>>;
    static null<a>(value: a): Decoder<a>;
    static nullable<a>(decoder: Decoder<a>): Decoder<Option<a>>;
    static number(): Decoder<number>;
    static oneOf<a>(decoders: NonEmptyArray<Decoder<a>>): Decoder<a>;
    static optionalField<a>(key: string, decoder: Decoder<a>): Decoder<Option<a>>;
    static string(): Decoder<string>;
    static succeed<a>(value: a): Decoder<a>;
    static unknown(): Decoder<unknown>;
    run(value: unknown): Decoded<a>;
}
export declare type Decoded<a> = Validation<NonEmptyArray<string>, a>;
